Ruby master - Bug #4651

Bus Error using continuation on x86_64-darwin11.0.0 (Lion)
05/07/2011 02:38 PM - sferik (Erik Michaels-Ober)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: - Backport:

Description

=begin

The following code crashes with a Bus Error on Ruby 1.9.2-p136 and 1.9.2-p180 built for x86_64-darwin11.0.0 (Lion). The same
code works on both of those versions of Ruby built for x86_64-darwin10.0.0 (Snow Leopard).

(({require 'continuation'}))

(({cc = callce {|cc| cc }; ce.call if cc}))

This actual code appears in the yard gem on (()).

I've attached the crash log. Please let me know if you need any other information from me to help debug this issue. Thank you very

much. Ruby makes me happy.
=end

Related issues:

Related to Ruby master - Bug #5082: test_context_switch(TestMarshal) was fail... Closed 07/23/2011
Related to Ruby master - Bug #5181: yard causes Ruby 1.9.2 crash on Mac OS X ... Closed 08/10/2011
Related to Ruby master - Bug #5224: Yard seems to be crashing ruby. Closed 08/25/2011
Related to Ruby master - Bug #5263: Ruby crash when installing yard-0.7.2 ins... Closed 09/02/2011
Related to Ruby master - Bug #5931: Random SEGV during execution on YARD specs Rejected

Related to Ruby master - Bug #5973: Bus Error in simple project requiring YARD Closed 02/06/2012
Related to Ruby master - Bug #6387: 1.9.3p194 crashed on require in ubuntu Closed 05/02/2012
History

#1 - 05/07/2011 05:03 PM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Feedback

=begin
Does it reproduce

e with just those 2 lines?
¢ with “configure optflags=-O0 debugflags=-ggdb3'?
e with trunk? =end

#2 - 05/07/2011 10:47 PM - sferik (Erik Michaels-Ober)
=begin
® Yes,

* yes,
e and yes. =end

#3 - 05/08/2011 09:03 AM - nobu (Nobuyoshi Nakada)
- Project changed from Backport192 to Ruby master
- Status changed from Feedback to Open

- Priority changed from 5 to Normal

#4 - 05/08/2011 09:09 AM - nobu (Nobuyoshi Nakada)

OK, then could you show the crash log from the short code on the trunk compiled with '-O0 -ggdb3'?
And,

e does a binary compiled on Snow Leopard crash on Lion?
e does a binary compiled on Lion crash on Snow Leopard?

#5 - 05/08/2011 11:41 PM - nobu (Nobuyoshi Nakada)
- Tracker changed from Backport to Bug

#6 - 05/09/2011 12:11 AM - sferik (Erik Michaels-Ober)
| just tried reproducing on trunk with '-O0 -ggdb3' but | could not reproduce the error.

I'm not sure if a binary compiled on Snow Leopard crashes on Lion or vice versa. | think the binary | had previously compiled for Snow Leopard was
working until | recompiled it for Lion.

#7 - 05/12/2011 03:13 AM - sferik (Erik Michaels-Ober)

Just to be clear, this is still an issue on Ruby 1.9.2-head but it's fixed in trunk (1.9.3). Maybe I'm using the wrong terminology for branches? Sorry
about that. Just wanted to clarify.

#8 - 06/12/2011 11:40 PM - levinalex (Levin Alexander)
- File config.log added

| just ran into this on Snow Leopard after reinstalling rvm [1]. | am using Xcode 4.2 (4C104)
config.log is attached.

$ cat cc.rb

require 'continuation’
x =callcc{|b|b}
x.call

$ which ruby
/Users/levin/.rvm/rubies/ruby-1.9.2-head/bin/ruby

$ ruby cc.rb
cc.rb:2: [BUG] Bus Error
ruby 1.9.2p274 (2011-06-06 revision 31932) [x86_64-darwin10.7.0]

-- control frame ----------

¢:0004 p:---- s:0010 b:0010 1:000009 d:000009 CFUNC :callcc
¢:0003 p:0021 s:0007 b:0007 1:0014e8 d:001720 EVAL cc.rb:2
€:0002 p:---- s:0004 b:0004 1:000003 d:000003 FINISH

c:0001 p:0000 s:0002 b:0002 1:0014e8 d:0014e8 TOP

-- Ruby level backtrace information
cc.rb:2:in <main>'
cc.rb:2:incallcc'

-- C level backtrace information

0 libruby.1.9.1.dylib 0x00000001001404fe rb_vm_bugreport + 110
1 libruby.1.9.1.dylib 0x0000000100034513 report_bug + 259

2 libruby.1.9.1.dylib 0x0000000100034681 rb_bug + 161

3 libruby.1.9.1.dylib 0x00000001000d6f72 sigbus + 18

4 libSystem.B.dylib 0x00007fff80fa466a _sigtramp + 26

5 77?7 0x000000010027c000 0x0 + 4297572352
[NOTE]

You may have encountered a bug in the Ruby interpreter or extension libraries.
Bug reports are welcome.
For details: http://www.ruby-lang.org/bugreport.html

Abort trap

[1] rvm 1.6.20, installed after deleting ~/.rvm directory

#9 - 06/13/2011 01:25 AM - levinalex (Levin Alexander)
- File config.log.xcode4.0.2.txt added

| downgraded to XCode 4.0.2 (4A2002a) and recompiled ruby with rvm. This makes the problem go away. (both for 1.9.2p180 and p274)
$ ruby --version

ruby 1.9.2p180 (2011-02-18 revision 30909) [x86_64-darwin10.7.0]

$ ruby cc.rb

cc.rb:3:in <main>": undefined methodcall' for nil:NilClass (NoMethodError)

no crash :)

attached is the config.log from this compilation for comparison.
#10 - 06/13/2011 01:43 AM - levinalex (Levin Alexander)
diffing both config.log files:

the segfaulting ruby (XCode 4.2) is compiled with:

gcc version 4.2.1 (Based on Apple Inc. build 5658) (LLVM build 2335.15.00)
i686-apple-darwin10-livm-g++-4.2 (GCC) 4.2.1 (Based on Apple Inc. build 5658) (LLVM build 2335.15.00)

the working ruby (XCode 4.0) is compiled with:

gcc version 4.2.1 (Apple Inc. build 5666) (dot 3)
i686-apple-darwin10-g++-4.2.1 (GCC) 4.2.1 (Apple Inc. build 5666) (dot 3)

#11 - 06/13/2011 01:56 AM - sorah (Sorah Fukumori)
- Status changed from Open to Feedback

- Priority changed from Normal to 3

- ruby -v set to -

Hi,

thank you for your testing.

Could you test without rvm (compile with your hands!)?
Also, if you can, could you test at the ruby svn trunk?

and Lion is not released, so we can't support well.
please understand that.

thanks.

#12 - 06/13/2011 01:57 AM - sorah (Sorah Fukumori)

oops sorry, i missed looking old replies...

#13 - 06/14/2011 12:37 AM - levinalex (Levin Alexander)

- File CrashReports_ruby 2011-06-13-173007_rhea.zip added

- File ruby_make_test output.txt added

Can reproduce with ruby built from source without rvm.

(this does not seem to be caused by using continuations, this seems to be a more general problem when building with XCode 4.2.0)
Okay, | reinstalled XCode 4.2 and did the following:

$ git clone git:/github.com/ruby/ruby.git

this is trunk, revision 57ed1e9d75360713c3d5d75c4cbb05ea48c8b025

$ cd ruby

$ autoconf && ./configure && make

$ /ruby -v

ruby 1.9.3dev (2011-06-13 trunk 32068) [x86_64-darwin10.7.0]
$ make test

make test has multiple failures. (output and crash reports are attached)

Is there anything | can do to help chase this?
#14 - 06/26/2011 12:43 AM - levinalex (Levin Alexander)
this seems to be fixed in trunk by https:/github.com/ruby/ruby/commit/be953b4d1ce3f0dfc7f24c84ec7a51e027102557

(tested with the latest XCode Beta, Version 4.2 (4C114))
the commit applies cleanly on ruby_1_9 2 and also fixes make test there. any chance that it will be backported before OS X Lion is released?

#15 - 06/26/2011 06:52 PM - naruse (Yui NARUSE)
- Status changed from Feedback to Closed

#16 - 07/23/2011 04:31 AM - mbleigh (Michael Bleigh)

I'm sorry, but I'm not sure what the resolution of this is for it to be closed. I've just run into the same error with 1.9.2-head (works in 1.9.3-head) on
RVM. Is this a fix that is going to be applied to the 1.9.2 branch or is it going to remain unpatched until 1.9.3?

#17 - 07/23/2011 10:37 AM - sikachu (Prem Sichanugrist)

@Micheal Bleigh

There's a ticket #4945 which in the backport92 project. | think they'll backport that soon.
#18 - 04/16/2012 01:28 PM - naruse (Yui NARUSE)

mbleigh (Michael Bleigh) wrote:

I'm sorry, but I'm not sure what the resolution of this is for it to be closed. I've just run into the same error with 1.9.2-head (works in 1.9.3-head)
on RVM. Is this a fix that is going to be applied to the 1.9.2 branch or is it going to remain unpatched until 1.9.3?

The main thread of this problem is #5082 and it is fixed in Ruby 1.9.3-p125.
Yugui, the maintainer of 1.9.2 release branch, may handle the backport, but | don't know the status.
| think you should update to 1.9.3.

Files

ruby_2011-05-06-223300_leon.crash 9.71 KB 05/07/2011 sferik (Erik Michaels-Ober)
config.log 589 KB 06/12/2011 levinalex (Levin Alexander)
config.log.xcode4.0.2.txt 586 KB 06/13/2011 levinalex (Levin Alexander)
CrashReports_ruby_2011-06-13-173007_rhea.zip 15.1 KB 06/14/2011 levinalex (Levin Alexander)
ruby_make_test_output.txt 20.1 KB 06/14/2011 levinalex (Levin Alexander)
